//                           " "
//      n*n.     ,
//  ,    , ,    
//     .
//          ,
//    .
//              .
//  ,     .

Unit Unit1;

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;
Const n=12;            //  
      Max=n*n-1;       //   

Type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Pole:array[1..n,1..n] of integer;
  Start,Fin:tPoint;
  Way,BestWay:Record
                  kJump:integer;                  //   
                  Broad:array[0..Max] of tPoint;  //   
              end;
  nVariants:Extended; //   

Implementation

{$R *.dfm}

Procedure DrawRezult;
Var i,j,Hx,Hy,dx,dy,c:integer;
    p1,p2:boolean;
    x,y,xx,yy:integer;
    s:string;
begin
   With Form1.image1.Canvas do begin
      Hx:=Form1.image1.Width;
      Hy:=Form1.image1.Height;
      dx:=Hx Div n;
      dy:=Hy Div n;
      Brush.Color:=clWhite;
      For i:=1 to n do
      For j:=1 to n do begin
          p1:=(i=Start.Y) And (j=Start.X);
          p2:=(i=Fin.Y) And (j=Fin.X);
          If p1 then c:=RGB(0,255,0);
          If p2 then c:=RGB(255,155,0);
          If Not p1 And Not p2 then c:=clWhite;
          Brush.Color:=c;
          Rectangle(dx*(j-1),dy*(i-1),dx*j,dy*i);
          Font.Size:=5;
          TextOut(dx*(j-1)+dx Div 3,dy*(i-1)+dy Div 3,IntToStr(Pole[j,i]));
      end;
      Form1.ListBox1.Items.Add('');
      Form1.ListBox1.Items.Add('');
      Form1.ListBox1.Items.Add('=');
      Form1.ListBox1.Items.Add(FloatToStr(nVariants));
      If BestWay.kJump=Max then begin
       Form1.ListBox1.Items.Add(' .');
       Exit
   end;
   For i:=0 to BestWay.kJump do begin
        s:=' '+IntToStr(i)+': '
           +IntToStr(BestWay.Broad[i].X)+' - '
           +IntToStr(BestWay.Broad[i].Y);
        Form1.ListBox1.Items.Add(s);
   end;
      Pen.Color:=clBlue;
      Pen.Width:=2;
      x:=Start.X;
      y:=Start.Y;
      Brush.Style:=bsClear;
      For i:=1 to BestWay.kJump do begin
          x:=BestWay.Broad[i-1].X;
          y:=BestWay.Broad[i-1].Y;
          xx:=BestWay.Broad[i].X;
          yy:=BestWay.Broad[i].Y;
          If (x=xx) And (y<yy) then
              Arc(x*dx-dx,y*dy-dy div 2,
                  x*dx,yy*dy-dy div 2,
                  x*dx-dx div 2,y*dy-dy div 2,
                  x*dx-dx div 2,yy*dy-dy div 2);
          If (x=xx) And (y>yy) then
              Arc(x*dx-dx,yy*dy-dy div 2,
                  x*dx,y*dy-dy div 2,
                  x*dx-dx div 2,yy*dy-dy div 2,
                  x*dx-dx div 2,y*dy-dy div 2);
          If (y=yy) And (x<xx) then
              Arc(x*dx-dx div 2,y*dy-dy,
                  xx*dx-dx div 2,y*dy,
                  x*dx-dx div 2,y*dy-dy div 2,
                  xx*dx-dx div 2,y*dy-dy div 2);
          If (y=yy) And (x>xx) then
              Arc(x*dx-dx div 2,y*dy-dy,
                  xx*dx-dx div 2,y*dy,
                  xx*dx-dx div 2,y*dy-dy div 2,
                  x*dx-dx div 2,y*dy-dy div 2);
      end;

      Brush.Color:=clWhite;
      Pen.Color:=clBlack;
      Pen.Width:=1;
   end;

end;

Function Povtor(k:integer;p:tPoint):boolean;
Var i:integer;
begin
   Povtor:=False;
   For i:=0 to k do
      If (p.X=Way.Broad[i].X) And (p.y=Way.Broad[i].y) then begin
         Povtor:=True;
         Exit
      end;
end;

Procedure Hod(i:integer;s:tPoint;Var s1:tPoint;Var p:boolean);
Var   Jump:integer;
begin
   Jump:=Pole[s.X,s.Y];
   s1:=s;
   Case i of
      1:begin
          s1.X:=s.X+Jump;
      end;
      2:begin
          s1.Y:=s.y+Jump;
      end;
      3:begin
          s1.X:=s.X-Jump;
      end;
      4:begin
          s1.Y:=s.y-Jump;
      end;
   End;
   p:=(s1.x>0) And (s1.x<=n) And (s1.Y>0) And (s1.Y<=n)
end;

Procedure Solve(k:integer;Position:tPoint);
Var i:integer;
    Position1:tPoint;
    Maybe:boolean;
begin
   If k>Max then Exit;
   If k>=BestWay.kJump then begin
        nVariants:=nVariants+1;
        Exit;
   end;
   Way.kJump:=k;
   Way.Broad[k]:=Position;
   If (Position.X=Fin.X) And (Position.y=Fin.y) then begin
       BestWay:=Way;
       nVariants:=nVariants+1;
       Exit
   end;
   For i:=1 to 4 do begin
      Hod(i, Position, Position1,Maybe);
      If Maybe And Not Povtor(k,Position1) then Solve(k+1,Position1);
      nVariants:=nVariants+1;
   end;
end;

Procedure TForm1.Button1Click(Sender: TObject);
Var i,j:integer;
begin
    ListBox1.Clear;
    Start.X:=StrToInt(Edit1.Text);
    Start.y:=StrToInt(Edit2.Text);
    Fin.X:=StrToInt(Edit3.Text);
    Fin.y:=StrToInt(Edit4.Text);
    For i:=1 to n do
      For j:=1 to n do Pole[i,j]:=1+Random(10);
    BestWay.kJump:=Max;
    nVariants:=0;
    Solve(0,Start);
    DrawRezult;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Close
end;

end.
