//       
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

Const nTown=100;
      nOsobi=100;
      AllGen:Set of Byte=[1..nTown];

Type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    ListBox1: TListBox;
    StringGrid1: TStringGrid;
    Button3: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  Data=Record
     Marshrut:Array[1..nTown] of Byte;
     Dlina:integer;
  End;

var
  Form1: TForm1;
  d:array[1..nTown,1..nTown] of integer;
  Osobi:array[1..2*nOsobi] of Data;
  OptOsob:Data;
  Min:integer;

implementation

{$R *.dfm}
//   
Procedure Generation;
Var i,j,x,k1,k2,L:integer;
    m:Set of Byte;
    s:String;
    F:textfile;
begin
    //
    AssignFile(f,'Data.txt');
    {Rewrite(f);
    Writeln(f,nTown);
    For i:=1 to nTown do
    For j:=1 to nTown do d[i,j]:=1+Random(100);
    For i:=1 to nTown do d[i,i]:=0;
    For i:=1 to nTown do begin
      For j:=1 to nTown do Write(f,d[i,j],' ');
      Writeln(f)
    end;
    CloseFile(f);
    Exit;}

    Reset(f);
    Readln(f,x);
    For i:=1 to nTown do begin
        For j:=1 to nTown do Read(f,d[i,j]);
        Readln(f);
    end;
    With Form1.StringGrid1 do begin
        RowCount:=nTown+1;
        ColCount:=nTown+1;
        For i:=1 to nTown do Cells[i,0]:=IntTostr(i);
        For i:=1 to nTown do Cells[0,i]:=IntTostr(i);

        For i:=1 to nTown do
        For j:=1 to nTown do Cells[j,i]:=IntToStr(d[i,j])
    end;


    //Randomize;
    Min:=MaxInt;
    For i:=1 to nOsobi do begin
       j:=1;
       m:=AllGen;
       Repeat
          x:=1+Random(nTown);
          If x in m then begin
              Osobi[i].Marshrut[j]:=x;
              m:=m-[x];
              j:=j+1;
          end;
       Until j>nTown;
       L:=0;
       For j:=1 to nTown-1 do begin
          k1:=Osobi[i].Marshrut[j];
          k2:=Osobi[i].Marshrut[j+1];
          L:=L+d[k1,k2]
       end;
       Osobi[i].Dlina:=L;
       If L<Min then begin
           Min:=L;
           For j:=1 to nTown do OptOsob.Marshrut[j]:=Osobi[i].Marshrut[j];
           OptOsob.Dlina:=L
       end;
    end;
    //
    For i:=1 to nOsobi do begin
        s:='';
        For j:=1 to nTown do s:=s+' '+IntToStr(Osobi[i].Marshrut[j]);
        s:=s+' '+IntToStr(Osobi[i].Dlina);
        Form1.ListBox1.Items.Add(s)
    end;
end;

//   
Procedure Division;
Var i,j,k,L:integer;
    s1,s2,s3,s4:string;
    Osob1:Data;

begin
    For i:=1 to nOsobi do begin
        k:=1+Random(nTown);
        For j:=1 to k do Osobi[i+nOsobi].Marshrut[nTown-k+j]:=Osobi[i].Marshrut[j];
        For j:=k+1 to nTown do Osobi[i+nOsobi].Marshrut[j-k]:=Osobi[i].Marshrut[j];
        L:=0;
        For j:=1 to nTown-1 do L:=L+d[Osobi[i+nOsobi].Marshrut[j],Osobi[i+nOsobi].Marshrut[j+1]];
        Osobi[i+nOsobi].Dlina:=L;

        If L<Min then begin
          Min:=L;
          For j:=1 to nTown do OptOsob.Marshrut[j]:=Osobi[i+nOsobi].Marshrut[j];
          OptOsob.Dlina:=L
        end;
    end;
end;

//  
Procedure Mutation;
Var j,k,k1,k2,x,L:integer;
    q:real;
begin
    q:=Random;
    If q>0.05 then Exit;

    k:=1+Random(nOsobi);
    k1:=1+Random(nTown);
    k2:=1+Random(nTown);
    With Osobi[k] do begin
       x:=Marshrut[k1];
       Marshrut[k1]:=Marshrut[k2];
       Marshrut[k2]:=x;
    end;

    L:=0;
    For j:=1 to nTown do
        L:=L+d[Osobi[k].Marshrut[j],Osobi[k].Marshrut[j+1]];
    Osobi[k].Dlina:=L
end;

Procedure Sort;
Var i,j:integer;
    Osob:Data;
begin
    For i:=1 to 2*nOsobi-1 do
    For j:=i+1 to 2*nOsobi do
        If Osobi[i].Dlina>Osobi[j].Dlina then begin
            Osob:=Osobi[i];
            Osobi[i]:=Osobi[j];
            Osobi[j]:=Osob
        end;
end;


procedure TForm1.Button1Click(Sender: TObject);
Var i,j:integer;
    s:String;
begin
    //  
    For i:=1 to 1000 do begin
        Division;
        Mutation;
        Sort;
    end;

    s:='';
    For j:=1 to nTown do s:=s+' '+IntToStr(OptOsob.Marshrut[j]);
    s:=s+' '+IntToStr(OptOsob.Dlina);
    Memo1.Lines[0]:=s;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    //  
     Generation;
end;

end.
