unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

Const n=4;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  SetInt=Set of byte;
var
  Form1: TForm1;
  a:array[1..n*n] of integer;
  Matrix:array[1..n,1..n] of integer;
  m0,k0:integer;

Implementation
{$R *.dfm}

Procedure MakeMatrix;
Var i,j,k:integer;
begin
  k:=0;
  For i:=1 to n do
  For j:=1 to n do begin
      k:=k+1;
      Matrix[i,j]:=a[k]
  end;
end;

Function Proverka:boolean;
Var i,j,s:integer;
begin
   //   
   For i:=1 to n do begin
     s:=0;
     For j:=1 to n do s:=s+Matrix[i,j];
     If s<>m0 then begin
       Proverka:=False;
       Exit
     end;
   end;
   //   
   For j:=1 to n do begin
     s:=0;
     For i:=1 to n do s:=s+Matrix[i,j];
     If s<>m0 then begin
       Proverka:=False;
       Exit
     end;
   end;
   //    
   s:=0;
   For i:=1 to n do s:=s+Matrix[i,i];
   If s<>m0 then begin
       Proverka:=False;
       Exit
   end;
   //    
   s:=0;
   For i:=1 to n do s:=s+Matrix[i,n-i+1];
   If s<>m0 then begin
       Proverka:=False;
       Exit
   end;

   Proverka:=True
end;


Procedure Perebor(k:integer;m:SetInt;ss:integer);
Var i,j:integer;
    s:string;
begin
   If m=[] then begin
       MakeMatrix;
       If Proverka then begin
            Application.ProcessMessages;
            k0:=k0+1;
            Form1.ListBox1.Items.Add(IntToStr(k0));
            For i:=1 to n do begin
               s:='';
               For j:=1 to n do s:=s+' '+IntToStr(Matrix[i,j]);
               Form1.ListBox1.Items.Add(s)
            end;
            Form1.ListBox1.Items.Add(' ');
       end;

       Exit
   end;

   For i:=1 to n*n do
     If i in m then begin
         a[k]:=i;
         If (k=n) And (ss+i<>m0) then Continue;
         If (k=2*n) And (ss+i<>2*m0) then Continue;
         If (k=3*n) And (ss+i<>3*m0) then Continue;
        // If (k=4*n) And (ss+i<>4*m0) then Continue;
         Perebor(k+1,m-[i],ss+i)
     end;
end;

procedure TForm1.Button1Click(Sender: TObject);
Var i,t1,t2:integer;
begin
    m0:= n*(n*n + 1) Div 2;
    ListBox1.Clear;
    k0:=0;
    t1:=GetTickCount;
    Perebor(1,[1..n*n],0);
    t2:=GetTickCount;
    Label1.Caption:=IntToStr(t2-t1)
end;

end.
