Function F(x1,x2:real):real;
begin
   //F:=-x1*x1+x2*x2
   F:=Sin(x1)+Sin(x2)
end;

Procedure Schet;
Var i,j,k:integer;
    dx:RealVector;
    Centre:RealVector;
begin
   With frmMain do begin
     MinX[1]:=StrToFloat(Edit1.Text);
     MaxX[1]:=StrToFloat(Edit2.Text);
     MinX[2]:=StrToFloat(Edit3.Text);
     MaxX[2]:=StrToFloat(Edit4.Text);
     Angle[1]:=StrToFloat(Edit7.Text)*2*Pi/360;
     Angle[2]:=StrToFloat(Edit8.Text)*2*Pi/360;
     Angle[3]:=StrToFloat(Edit9.Text)*2*Pi/360;
   end;

   For i:=1 to 2 do dx[i]:=(MaxX[i]-MinX[i])/nGrid;

   MinX[3]:=1e38;MaxX[3]:=-1e38;
   For i:=0 to nGrid do
      For j:=0 to nGrid do begin
          x[i,j,1]:=MinX[1]+dx[1]*i;
          x[i,j,2]:=MinX[2]+dx[2]*j;
          x[i,j,3]:=F(x[i,j,1],x[i,j,2]);
          If MinX[3]>x[i,j,3] then MinX[3]:=x[i,j,3];
          If MaxX[3]<x[i,j,3] then MaxX[3]:=x[i,j,3];
      end;

   For i:=1 to 3 do begin
      Centre[i]:=(MinX[i]+MaxX[i])/2;
      dx[i]:=Centre[i]-MinX[i];
   end;

   For i:=0 to nGrid do
      For j:=0 to nGrid do
          For k:=1 to 3 do
             x[i,j,k]:=(x[i,j,k]-Centre[k])/dx[k]//(MaxX[k]-MinX[k]);
end;

Procedure Rotate;
Var xx,yy:real;
    i,j,k:integer;
begin
   For i:=1 to 3 do begin
      Min[i]:=1e38;
      Max[i]:=-1e38
   end;
   x1:=x;
   For i:=0 to nGrid do
      For j:=0 to nGrid do begin
          xx:=x[i,j,2];yy:=x[i,j,3];
            x[i,j,2]:= xx*Cos(Angle[1])+yy*Sin(Angle[1]);
            x[i,j,3]:=-xx*Sin(Angle[1])+yy*Cos(Angle[1]);
          xx:=x[i,j,1];yy:=x[i,j,3];
            x[i,j,1]:= xx*Cos(Angle[2])+yy*Sin(Angle[2]);
            x[i,j,3]:=-xx*Sin(Angle[2])+yy*Cos(Angle[2]);
          xx:=x[i,j,1];yy:=x[i,j,2];
            x[i,j,1]:= xx*Cos(Angle[3])+yy*Sin(Angle[3]);
            x[i,j,2]:=-xx*Sin(Angle[3])+yy*Cos(Angle[3]);
          If Min[1]>x[i,j,1] then Min[1]:=x[i,j,1];
          If Min[2]>x[i,j,2] then Min[2]:=x[i,j,2];
          If Min[3]>x[i,j,3] then Min[3]:=x[i,j,3];
          If Max[1]<x[i,j,1] then Max[1]:=x[i,j,1];
          If Max[2]<x[i,j,2] then Max[2]:=x[i,j,2];
          If Max[3]<x[i,j,3] then Max[3]:=x[i,j,3];
      end; 
end;
