unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  x,y,z:array of integer;
  Conect:array of array of integer;
  s:array  of array of single;
  n:integer;

implementation

{$R *.dfm}

procedure TForm1.Button3Click(Sender: TObject);
begin
     Close
end;

Procedure DrawLine;
Var i,xg,yg,xg1,yg1:integer;
    MinX,MaxX,MinY,MaxY:integer;
begin
   MinX:=MaxInt;MaxX:=-MaxInt;
   MinY:=MaxInt;MaxY:=-MaxInt;
   For i:=1 to n do begin
      If MinX>x[i] then MinX:=x[i];
      If MinY>y[i] then MinY:=y[i];
      If MaxX<x[i] then MaxX:=x[i];
      If MaxY<y[i] then MaxY:=y[i];
   end;
   With Form1.Image1 do begin
      Canvas.Rectangle(0,0,Width,Height);
      For i:=1 to n do begin
          xg:=10+Round((Width-20)*(x[i]-MinX)/(MaxX-MinX));
          yg:=10+Round((Height-20)*(MaxY-y[i])/(MaxY-MinY));
          Canvas.Ellipse(xg-2,yg-2,xg+2,yg+2);
      end;
      For i:=1 to n-1 do begin
          xg:=10+Round((Width-20)*(x[Conect[i,0]]-MinX)/(MaxX-MinX));
          yg:=10+Round((Height-20)*(MaxY-y[Conect[i,0]])/(MaxY-MinY));
          Canvas.MoveTo(xg,yg);
          xg1:=10+Round((Width-20)*(x[Conect[i,1]]-MinX)/(MaxX-MinX));
          yg1:=10+Round((Height-20)*(MaxY-y[Conect[i,1]])/(MaxY-MinY));
          Canvas.LineTo(xg1,yg1);
      end;
   end;
end;

Procedure TForm1.Button1Click(Sender: TObject);
Var i:integer;
begin
    n:=StrToInt(Edit1.Text);
    SetLength(x,n+1);
    SetLength(y,n+1);
    SetLength(z,n+1);
    SetLength(Conect,n,2);
    SetLength(s,n+1,n+1);

    With StringGrid1 do begin
        RowCount:=n+1;
        Cells[1,0]:='x';
        Cells[2,0]:='y';
        Randomize;
        For i:=1 to n do begin
            x[i]:=Random(100);
            y[i]:=Random(100);
            z[i]:=0;
            Cells[0,i]:=IntToStr(i);
            Cells[1,i]:=IntToStr(x[i]);
            Cells[2,i]:=InttoStr(y[i]);
        end;
    end;
    //DrawPoint;
end;


Procedure TForm1.Button2Click(Sender: TObject);
Var i,j,k,MinI,MinJ:integer;
    Min:Single;
begin
     For i:=1 to n do
     For j:=1 to n do begin
          s[i,j]:=Sqrt(Sqr(x[i]-x[j])+Sqr(y[i]-y[j]));
     end;

     Min:=1e38;
     For i:=1 to n do
     For j:=1 to n do
       If (i<>j) And (s[i,j]<Min) then
       begin
             Min:=s[i,j];
             MinI:=i;
             MinJ:=j;
       end;
     z[MinI]:=1;z[MinJ]:=1;
     Conect[1,0]:=MinI;
     Conect[1,1]:=MinJ;

     For k:=2 to n-1 do begin
     Min:=1e38;
     For i:=1 to n do
     For j:=1 to n do
       If (i<>j) And
          ((z[i]=0) And (z[j]=1) Or ((z[i]=1) And (z[j]=0)))
          And (s[i,j]<Min) then
          begin
             Min:=s[i,j];
             MinI:=i;
             MinJ:=j;
          end;
     z[MinI]:=1;z[MinJ]:=1;
     Conect[k,0]:=MinI;
     Conect[k,1]:=MinJ;
     end;
     DrawLine;
end;

end.
