unit Unit1;

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls;
Const n=15; // rows
      m=20; //columns
Type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
   // procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
    //  Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  tMatrix=array[1..n,1..m] of integer;
Var
  Form1: TForm1;
  Karta:tMatrix;
  Zapret:array[1..n,1..m] of Boolean;
  Start,Fin:tPoint;

Implementation

{$R *.dfm}

Procedure Wave(y, x:integer);
Var i, j, kk: Integer;
    p1, p2, p3, p4,p5: Boolean;
Begin

  For i:= y - 1 To y + 1 do
    For j:= x - 1 To x + 1 do begin
        p1:= i<1;
        p2:= j<1;
        p3:= i>n;
        p4:= j>m;
        p5:= (i = y) And (j = x);
        If Not (p1 Or p2 Or p3 Or p4 Or p5) Then
            If Not Zapret[i, j] And (Karta[i, j] > Karta[y, x] + 1) Then begin
                Karta[i, j]:= Karta[y, x] + 1;
                Wave(i, j)
            end
    end
End;

Procedure DrawRezult;
Var dx,dy,h,w,x,y:integer;
    Min,Imin,Jmin:integer;
    i,j,c:integer;
    p,p1,p2,p3:boolean;
begin
    W:=Form1.Image1.Width;
    H:=Form1.Image1.Height-20;
    dx:=W Div m;
    dy:=H Div n;
    With Form1.Image1.Canvas do begin
      Pen.Color:=clBlack;
      Pen.Width:=1;
      For i:=1 to n do
      For j:=1 to m do begin
         p1:=(i=Start.Y) And (j=Start.X);
         p2:=(i=Fin.Y) And (j=Fin.X);
         p3:=Zapret[i,j];
         If p1 then c:=RGB(0,255,0);
         If p2 then c:=RGB(255,155,0);
         If p3 then c:=clGray;
         If Not p1 And Not p2 And Not p3 then c:=clWhite;
         Brush.Color:=c;
         Rectangle(dx*(j-1),dy*(i-1),dx*j,dy*i);

         If Karta[i,j]<>1000 then
           TextOut(dx*(j-1)+dx Div 3,dy*(i-1)+dy Div 3,IntToStr(Karta[i,j]))
      end;

      p:=False;
      x:=Fin.X;y:=Fin.Y;
      Pen.Color:=clBlue;
      Pen.Width:=3;
      While Not p do begin
         Min:=Karta[y,x];
         For i:=y-1 to y+1 do
         For j:=x-1 to x+1 do
            If Not ((i<1) Or (j<1) Or (i>n) Or (j>m)) And (Karta[i,j]<Min)
            then begin
               Min:=Karta[i,j];
               Imin:=i;
               Jmin:=j
            end;
         MoveTo(x*dx-dx Div 2,y*dy-dy Div 2);
         x:=Jmin;y:=Imin;
         LineTo(x*dx-dx Div 2,y*dy-dy Div 2);
         p:=(x=Start.X) And (y=Start.Y);
      end;   
    end;
end;


procedure TForm1.Button1Click(Sender: TObject);
Var i,j:integer;
    p,p1,p2,p3:boolean;
    Nomer1,Nomer2:integer;
begin
    For i:=1 To n do
    For j:=1 To m do Zapret[i, j]:= False;

    For i:=1 To n do
    For j:=1 To m do begin
        Karta[i,j]:= 1000;
        Zapret[i,j]:=False
    end;

    For i:= 2 To 13 do Zapret[i, 5]:= True;
    For i:= 1 To 11 do Zapret[i, 8]:= True;
    For i:= 9 To 14 do Zapret[8, i]:= True;
    For i:= 7 To 14 do Zapret[13, i]:= True;

   { Start.X:=2;
    Start.Y:=3;
    Fin.X:=10;
    Fin.Y:=2;}

    Repeat
      Start.X:=1+Random(m);
      Start.Y:=1+Random(n);
      Fin.X:=1+Random(m);
      Fin.Y:=1+Random(n);
      p1:=(Start.X=Fin.X) And (Start.Y=Fin.Y);
      p2:=Zapret[Start.Y,Start.X];
      p3:=Zapret[Fin.Y,Fin.X];
      p:=p1 Or p2 Or p3
    Until Not p;
    Karta[Start.Y,Start.X]:=0;
    Wave(Start.Y,Start.X);
    DrawRezult;
end;
end.


